#!/usr/bin/perl -w
#----------------------------------------------------------
# apply_service_form.pl
# part of webconf-package for eisfair
# last modified: 2003/09/14
# (c) 2002-2003 by Christian Wuerdig (eisfair@chriswue.de)
#----------------------------------------------------------

use strict;
use CGI::Carp qw(fatalsToBrowser);
use Fcntl ':flock';
use syntax;
use formtools;

our $VERBOSE;

no strict "subs";
do "conf.pl";
use strict "subs";

my ($class, $result_file, $apply_path, $apply_script) = ("class=\"result\"",  "/var/config/tmp/service_form.res", "/var/install/servadm", $ARGV[0]);
my ($temp_path, $temp_form, $form_string) = ("/var/config/tmp", $ARGV[1]);
$apply_script =~ s/%23/#/g;

# get form-Data
read(STDIN, $form_string, $ENV{CONTENT_LENGTH});

# decode chars in $form_string (defined in syntax.pm)
my @form = decode_formstr($form_string);

my (%regex_hash, %err_hash, @regex_list, $name, $val);

# read the match-regex and error messages
open(TMPFORM, "<$temp_path/$temp_form") || die("Could not open '$temp_form' for reading, reason: $!");
while(<TMPFORM>) {
   s/\n$//;
   if (/-err=/) {
      ($name, $val) = split(/=/, $_, 2);
      $name =~ s/-err$//;
      $err_hash{"$name"} = $val; 
   }
   else { push(@regex_list, $_); }
}
close(TMPFORM);

# substitude predefined reg. expressions; defined in syntax.pm
@regex_list = subst_preregex(@regex_list);

foreach(@regex_list) {
   ($name, $val) = split(/=/, $_, 2);
   $regex_hash{"$name"} = $val;
}
   
my (%option, %regex, %error, %form_hash);

# make hash from form-data
foreach (@form) {
   ($name, $val) = split(/=/, $_, 2);
   if (exists $form_hash{"$name"}) { $form_hash{"$name"} .= "\n$val"; }
   else { $form_hash{"$name"} = "$val"; }
}

# make optname-, value- and regex-list
while (($name, $val) = each(%form_hash)) {
   my @tmp = split(/\n/, $val);
   if ($#tmp > 0) {
      foreach my $idx (0 .. $#tmp) {
         $option{"$name\_$idx"} = "".$tmp[$idx];
         $regex{"$name\_$idx"} = $regex_hash{"$name"};
         $error{"$name\_$idx"} = $err_hash{"$name"};
      }
   }
   else {
      $option{"$name"} = "".$val;
      $regex{"$name"} = $regex_hash{"$name"};
      $error{"$name"} = $err_hash{"$name"};
   }
}

if ($apply_script !~ /^#(.*)#$/) {
   print_head_min("applying service form", $class);
   print "<pre $class>\n";
   print "checking form with regexp's ... " if ($VERBOSE eq "yes");
}

# check options with regexp's
my ($failed, $yes, $target) = (0, 0, "");
use re 'taint';
use re 'eval';
foreach(keys(%regex)) {
   if ($option{"$_"} !~ /$regex{$_}/) {
      $failed = 1;
      $error{"$_"} =~ s/\%v/$option{$_}/;
      print "\n<b $class>Error</b> in <b $class>$_</b>: ", $error{"$_"};
   } elsif ($yes == -1) {
      $failed = 1; $yes = 0;
      print "\n<b $class>Error</b> in <b $class>$_</b>: Directory '$target' doesn't exist!";
   } elsif ($yes == -2) {
      $failed = 1; $yes = 0;
      print "\n<b $class>Error</b> in <b $class>$_</b>: Directory '$target' mustn't exist!";
   } elsif ($yes == -3) {
      $failed = 1; $yes = 0;
      print "\n<b $class>Error</b> in <b $class>$_</b>: File '$target' doesn't exist!";
   } elsif ($yes == -4) {
      $failed = 1; $yes = 0;
      print "\n<b $class>Error</b> in <b $class>$_</b>: File '$target' mustn't exist!";
   }
}
no re 'eval';
no re 'taint';

if (!$failed) {
   if ($apply_script !~ /^#(.*)#$/) {
      print "done\n" if ($VERBOSE eq "yes");
      print "saving data ... " if ($VERBOSE eq "yes");
   }
   open(DATA, ">$result_file") || print "could not open '$result_file' for writing, reason: $!.<br>\n";
   flock(DATA, LOCK_EX);
   if (!$!) { foreach(keys(%option)) { print DATA "$_='$option{$_}'\n"; } }
   flock(DATA, LOCK_UN);
   close(DATA);
   if ($apply_script =~ /^#(.*)#$/) { exec("/usr/bin/perl", "make_service_form.pl", "$1"); }
   elsif (-f "$apply_path/$apply_script") {
      print "done\n\n" if ($VERBOSE eq "yes");
      print "applying config ... \n" if ($VERBOSE eq "yes");
      my $Output = `$apply_path/$apply_script`;
      print "$Output\n";
      print ".done\n" if ($VERBOSE eq "yes");
   }
   else { print "Error: skript '$apply_script' not found\n"; }
}
else { print "\nconfig <b $class>NOT</b> applied due to Syntaxerrors!<br>\n"; }

if ($apply_script !~ /^#(.*)#$/) {
   print "</pre>\n";
   print "</body></html>\n";
}
