#!/usr/bin/perl -w
#----------------------------------------------------------
# make_choose_servopt.pl
# part of webconf-package for eisfair
# $Id: make_choose_servopt.pl,v 1.6 2004/03/07 23:36:53 chriswue Exp $
# (c) 2002-2004 by Christian Wuerdig (eisfair@chriswue.de)
#----------------------------------------------------------
use strict;
use CGI::Carp qw(fatalsToBrowser);
use formtools;
use syntax;

our $VERBOSE;

no strict "subs";
do "conf.pl";
use strict "subs";

my $tag_option_on = '^[ \t]*<option ';
my $tag_conf_on = '^[ \t]*<config ';
my $tag_doc_on = '^[ \t]*<doc ';
my $tag_empty = '^[ \t]*<empty\/>[ \t]*(#.*)?\s*$';
my $tag_comment_emptyline = '^[ \t]*#.*\s*$|^\s*$';

my ($class, $form_path, $form_file, $idx, $name, $func) = ("class=\"chooseopt\"", "/var/install/form", $ARGV[0], 0, "", "");
my $creation_time = localtime(time);

my $tmp = `rm -f /var/config/tmp/.* >/dev/null 2>&1`;

open(FORM, "<$form_path/$form_file");
LINE: while(<FORM>) {
   $idx++;
   if (/^[ \t]*<menuname>(.*?)<\/menuname>([ \t]*#.*?)?\s*$/) {
      $name = $1;
      print_head("$1", "$1", "$class");
      add_history("$1#make_choose_servopt.pl+$ARGV[0]");
      print_history;
      print "<hr $class>\n";
      print "<p><br><br><br></p>";
      print "<p $class>\n";
      print "<ol $class>\n";
   } elsif (/$tag_comment_emptyline/) { # do nothing
   } elsif (/$tag_empty/) {
      print "<br>\n";
   } else {
      if (!$name) { printErr($form_file, $idx, "'<menuname>'", "'$_'"); last LINE; }
      my %ohash = get_tag_opt($_);
      if (/$tag_option_on/) {
         if (!$ohash{"name"})                    { printErr($form_file, $idx, "'name' in '<option>'", "'$_'"); next LINE; }
         if (!($ohash{"form"} || $ohash{"menu"} || $ohash{"func"})) {
            printErr($form_file, $idx, "'form', 'func' or 'menu' in '<option>'", "'$_'");
            next LINE;
         }
         if ($ohash{"form"}) {   # service formular
            print "<li $class><a $class href=\"make_service_form.pl?$ohash{form}\">$ohash{name}</a></li>\n";
         } elsif ($ohash{"menu"}) {    # new menu
            open(FORMF, "<$form_path/$ohash{menu}");
            NEW_FORM: {
               while(<FORMF>) {
                  if (/^( |\t)*<menuname>(.*)<\/menuname>(( |\t)*#.*)?\s*$/) { $name = $2; last NEW_FORM; }
               }
               printErr($ohash{"menu"}, 1, "'<menuname>'", "unexpected end of '$ohash{menu}'");
            }
            close(FORMF);
            print "<li $class><a $class href=\"make_choose_servopt.pl?$ohash{menu}\">$name</a></li>\n";
         } else {    # direct function
            $func = encode_string($ohash{"func"});
            print "<li $class><a $class href=\"do_func.pl?$func\" target=\"Result\">$ohash{name}</a></li>\n";
         }
      } elsif (/$tag_conf_on/) {
         if (!$ohash{"form"}) { printErr($form_file, $idx, "'<form>' in conf", "'$_'"); next LINE; }
         if (!$ohash{"name"}) { $ohash{"name"} = "Edit configuration"; }
         print "<li $class><a $class href=\"make_forms.pl?$ohash{form}\">$ohash{name}</a></li>\n";
      } elsif (/$tag_doc_on/) {
         if (!$ohash{"file"}) { printErr($form_file, $idx, "'<file>' in doc", "'$_'"); next LINE; }
         if (!$ohash{"name"}) { $ohash{"name"} = "View documentation"; }
         print "<li $class><a $class href=\"make_doc.pl?$ohash{file}\">$ohash{name}</a></li>\n";
      }
   }
}
close(FORM);

if ($name) {
   print "</ol></p>\n";
   print "<p><br><br><br></p>\n";
   print "<hr $class>\n";
  
  print_history;
   
   print "<hr $class>\n";
   print "<span>created by make_choose_servopt.pl on $creation_time.</span>\n" if ($VERBOSE eq "yes");
   print "</body></html>\n";
}
