#!/usr/bin/perl -w
#--------------------------------------------------------------
# make_doc.pl
# part of webconf-package for eisfair
# based on ascii2html.sh, (c) Eric Maryniak, e.maryniak@rgd.nl
# modified by J. Edner
# adapted to webconf by Christian Wuerdig
# last modified: 2003/11/15
# (c) 2002-2003 by Christian Wuerdig (eisfair@chriswue.de)
#--------------------------------------------------------------

use strict;
use CGI::Carp qw(fatalsToBrowser);
use formtools;

our $VERBOSE;

no strict "subs";
do "conf.pl";
use strict "subs";

my ($class, $doc_file, $creation_time)= ("class=\"servform\"", $ARGV[0], scalar(localtime(time)));

print_head("Documentation", "Documentation", $class);
add_history("Documentation#make_doc.pl+$ARGV[0]");
print_history;
print "<hr $class>\n";
print "<p><br><br><br></p>\n";

print "<pre $class style=\"margin-left:5%\">\n";

open(DOC, "<$doc_file") || die("Couldn't open '$doc_file', reason: $!\n");
while (<DOC>)
{
   # remove carriage return
   $_ =~ s/\12//g;

   # remove end of file (^z)
   $_ =~ s/\26//g;

   # replace ampersand by its html code
   $_ =~ s/\&/\&amp\;/g;

   # replace < and > by its html code
   $_ =~ s/\</\&lt\;/g;
   $_ =~ s/\>/\&gt\;/g;

   # replace german umlaute by its html code
   $_ =~ s//\&auml\;/g;
   $_ =~ s//\&ouml\;/g;
   $_ =~ s//\&uuml\;/g;
   $_ =~ s//\&Auml\;/g;
   $_ =~ s//\&Ouml\;/g;
   $_ =~ s//\&Uuml\;/g;
   $_ =~ s//\&szlig\;/g;

   # replace 8-bit characters by a space
   $_ =~ s/[\177-\377]/ /g;

   print "$_\n";
}
close(DOC);

print "</pre>\n";
print "<p><br><br><br></p>\n";
print "<hr $class>\n";

print_history;

print "<hr $class>\n";
#print "<br>return to <a $class href=\"choose_design.pl?adm\" target=\"_parent\">Servicemenu</a>\n";
#print "<br>return to <a $class href=\"../index.html\" target=\"_parent\">Mainmenu</a>\n";
print "<span $class>created by make_service_form.pl on $creation_time.</span>\n" if ($VERBOSE eq "yes");
print "</body></html>\n";
