#!/usr/bin/perl -w
#----------------------------------------------------------
# show_help.pl
# part of webconf-package for eisfair
# last modified: 2003/09/14
# (c) 2002-2003 by Christian Wuerdig (eisfair@chriswue.de)
#----------------------------------------------------------

use strict;
use CGI::Carp qw(fatalsToBrowser);
use formtools;

my ($class, $help_file, $opt_name, $help_path) = ("class=\"help\"", $ARGV[0], $ARGV[1], "/var/install/help");
$opt_name =~ s/%23/#/g;

my $tag_help_on = "^[ \t]*<help name=\"$opt_name\">";
my $tag_help_off = '^[ \t]*<\/help>[ \t]*(#.*?)?\s*$';

my ($inhelp, $help) = (0, "");

open(HELP, "<$help_path/$help_file");
LINE: while(<HELP>) {
   if (/$tag_help_on/) { $inhelp = 1; next LINE; }
   if ($inhelp) {
      last LINE if (/$tag_help_off/);
      $help .= $_; 
   }
}
close(HELP);

print_head_min("Help", $class);

if (!$inhelp) {
   print "<p $class>no Help available for Option <b $class>$opt_name</b><br></p>\n";
} else {
   $help =~ s/\\</&lt;/g;
   $help =~ s/\\>/&gt;/g;
   $help =~ s/\\&/&amp;/g;
   $help =~ s/\\"/&quot;/g;
   $help =~ s//&auml;/g;
   $help =~ s//&Auml;/g;
   $help =~ s//&ouml;/g;
   $help =~ s//&Ouml;/g;
   $help =~ s//&uuml;/g;
   $help =~ s//&Uuml;/g;
   $help =~ s//&szlig;/g;
   print "<b $class>$opt_name</b><br><br>\n";
   print "<pre $class>$help</pre>\n";
}

print "</body></html>\n";
