#!/bin/sh
#------------------------------------------------------------------------------
# part of the webconf-package for EIS/FAIR
# create new certificate via CGI
# last update: 2003/06/07
# (c) 2002-2003 by Christian Wrdig (eisfair@chriswue.de)
#------------------------------------------------------------------------------

res="/var/config/tmp/service_form.res"
certconf="/usr/local/webconf/mini_httpd.cnf"
cert="/var/config/mini_httpd.pem"
tmp="/tmp/.certcnf.$$"

. $res

sed -e "s/\(countryName_default             = \).*/\1 $country/" \
    -e "s/\(stateOrProvinceName_default     = \).*/\1 $state/"   \
    -e "s/\(localityName_default            = \).*/\1 $city/"    \
    -e "s/\(0.organizationName_default      = \).*/\1 $org/"     \
    -e "s/\(0.commonName_default            = \).*/\1 $fqdn/" $certconf > $tmp

cp $tmp $certconf
rm -f $tmp

echo "The ssl-certificate for the web-configuration is now created"
echo
/usr/bin/openssl req -new -x509 -days 365 -nodes -batch \
   -config $certconf -out $cert -keyout $cert
echo
echo "check certificate settings"
echo
/usr/bin/openssl x509 -subject -dates -fingerprint -noout -in $cert

rm -f $res
